;*********************************************************************
; PROGRAME NAME: MOTION PLANNER
; AUTHOR       : XIAOSHAN PAN
; DATE CREATED : 10/09/2002
; DATE MODIFIED: 11/19/2002
;*********************************************************************

(defun C:SHOWPATH (/ STR MSG F X Y Z E angl len)
	;open a wheelchair configration file
 	(command "-units" "2" "4" "4" "2" "" "")
  	(setq SCALE 1.0)
	  
  	(alert "Choose a path file...")
	(setq MSG     "Path file"
	      FNAME    (getfiled MSG "" "" 8)
	      F        (open FNAME "r")
	) 
   	(setq STR (strcat "(" (read-line F) ")"))
        (setq STR (read STR))
  	(while (> (length STR) 3)
	    (progn
	    	(setq X   (car STR) STR (cdr STR))
  	    	(setq Y   (car STR) STR (cdr STR))
	        (setq Y   (* Y SCALE))
  	    	(setq Z   (car STR) STR (cdr STR))
	        (setq Z   (* Z SCALE))
  	    	(setq E   (car STR) STR (cdr STR))
  	    	(command "-insert" "WHEELCHAIR.dwg" (list Y Z) "1" "" E)
	        ;(command "_point" (list Y Z))
	    )  
	)  
        (alert "Path display complete!")
   	(close F)
)

(defun C:MOTIONPLAN (/ S_TEMP SS000 SS00 SS0 SS1 SS2 N NUM EN angel1 angel2 border lowerWorld upperWorld)
  	(setq SCALE 1.0)
   	;make sure it is at 0 layer
   	(command "-layer" "S" "0" "")
	(setq SS00 (ssadd))

  	;define border
	(command "-layer" "M" "TRUSH" "FREEZE" "TRUSH" "")

  	;change units
  	(changeUnits)
  
	;define border
	(command "-layer" "M" "BORDER" "")
	(command "-layer" "S" "BORDER" "")
	(command "_rectang" (setq lowerWorld (getpoint "LEFT-LOWER CORNER:")) (setq upperWorld (getpoint "RIGHT-UPPER CORNER:")) "")

  	;create datafile 'LowerWorld'
  	(setq STR (strcat
		"3 "
		(rtos (/ (car lowerWorld) SCALE)) " " 
		(rtos (/ (cadr lowerWorld) SCALE)) " "
		(rtos (/ (caddr lowerWorld) SCALE)) " "
		)
	)
  
  	;(setq MSG1     "Please name the file as 'LowerWorld'"
	;      FNAME    (getfiled MSG1 "" "" 1)
	;      F1       (open FNAME "w")
	;)
  	(setq F1 (open "LowerWorld" "w")) 
  
    	(write-line STR F1)
   	(setq F1 (close F1))

  	;create datafile 'upperWorld'
  	(setq STR (strcat
		"3 "
		(rtos (/ (car upperWorld) SCALE)) " " 
		(rtos (/ (cadr upperWorld) SCALE)) " "
		(rtos (/ (caddr upperWorld) SCALE)) " "
		)
	)	

  	;(setq MSG1     "Please name the file as 'UpperWorld'"
	;      FNAME    (getfiled MSG1 "" "" 1)
	;      F1       (open FNAME "w")
	;)
        (setq F1 (open "UpperWorld" "w")) 
  
    	(write-line STR F1)
   	(setq F1 (close F1))

   	;create datafile 'GlobalCameraPosition'
  	(setq STR
	    (strcat
		"3 "
		(rtos (/
			(/ (- (car upperWorld) (car lowerWorld)) 2)
			SCALE)
		) " " 
		(rtos (/
			(/ (- (cadr upperWorld) (cadr lowerWorld)) 2)
			SCALE)
		) " "
		(rtos (/
			(* (/ (- (cadr upperWorld) (cadr lowerWorld)) 2) 6)
			SCALE)
		         ;(/ SCALE 2))
		) " "
	    )
	)	

  	;(setq MSG1     "Please name the file as 'GlobalCameraPosition'"
	;      FNAME    (getfiled MSG1 "" "" 1)
	;      F1       (open FNAME "w")
	;)
	(setq F1 (open "GlobalCameraPosition" "w"))
  
    	(write-line STR F1)
   	(setq F1 (close F1)) 
	
	;turn off irrelavant layers
	(command "-layer" "FREEZE" "*" "")
	(command "-layer" "THAW" "BORDER" "")	

   	;get the boundary object
   	(command "select" "all" "")
   	(setq SS000 (ssget "_P") )
   	(setq EN (ssname SS000 0))
   	(if (= (DXF 0 EN) "LWPOLYLINE")
      		(setq VLIST (GET-LWVLIST EN))
      		(setq VLIST (GET-PLVLIST EN))
   	) 
   	(setq borderList (mapcar '(lambda (X) (trans X EN 0)) VLIST))
   	(setq numBorder (length borderList))
	(command "-layer" "THAW" "*" "")
	(command "-layer" "S" "0" "")
	(command "ZOOM" "E" "")

	;select robot's initial postion 
	(setq robotIni (getpoint "\nSelect initial position of the robot:"))
	(command "-insert" "WHEELCHAIR.dwg" robotIni "1" "" (setq angel1 (getint "Which way? "))) 
	(setq angel1 (* 0.01745329 angel1))
	(setq SS00 (ssadd (entlast) SS00))
	(setq robotGoa (getpoint "\nSelect goal position of the robot:"))
   	(command "-insert" "WHEELCHAIR.dwg" robotGoa "1" "" (setq angel2 (getint "Which way? "))) 
   	(setq angel2 (* 0.01745329 angel2))
   	(setq SS00 (ssadd (entlast) SS00))
	(command "erase" SS00 "")
	
   	(setq STR (strcat
		"3 "
		(rtos (/ (car robotIni) SCALE)) " " 
		(rtos (/ (cadr robotIni) SCALE)) " "
		(rtos angel1) " "
		)
   	)
	;trying to overwrite a file if exist already
	;(setq MSG1     "Please name the file as 'InitialState'"
	;      FNAME    (getfiled MSG1 "" "" 1)
	;      F1       (open FNAME "w")
	;)
        (setq F1 (open "InitialState" "w"))
  
    	(write-line STR F1)
   	(setq F1 (close F1))
  	;(alert "1st Datafile complete ")
    	(setq STR (strcat 
		"3 "
		(rtos (/ (car  robotGoa) SCALE)) " " 
		(rtos (/ (cadr robotGoa) SCALE)) " "
		(rtos angel2) " "
		)
   	)
  
	;trying to overwrite a file if exist already
	;(setq MSG1     "Please name the file as 'GoalState'"
	;      FNAME    (getfiled MSG1 "" "" 1)
	;      F1       (open FNAME "w")
	;)
  	(setq F1 (open "GoalState" "w"))
  
    	(write-line STR F1)
   	(setq F1 (close F1))
 
   	;(alert "2nd Datafile complete ")
   
	(setq SS0 (ssadd))

     	;(alert "Ready to generate the 3rd datafile")

	;trying to overwrite a file if exist already
	;(setq MSG3     "Please name the file as 'Obst'"
	;      FNAME    (getfiled MSG3 "" "" 1)
	;      F1       (open FNAME "w")
	;)
  	(setq F1 (open "Obst" "a"))
  
	;create a new layer, make sure it switch to the new layer.
	(command "-layer" "M" "OBSTACLE" "")
	(command "-layer" "S" "A-Wall" "")	
	;turn off irrelavant layers
	(command "-layer" "FREEZE" "*" "")


  	;save all wall objects into S_TEMP
     	(command "select" "all" "")
   	(setq S_TEMP (ssget "_P") ) 
   	(setq NUM (sslength S_TEMP))
  
	;(command "-layer"  "THAW" "BORDER" "")

	;handle wall individully
  	;1. create a buffer 'TEMP'
  	;2. loop through all walls
  	(command "-layer" "M" "TEMP" "")
	(command "-layer" "S" "TEMP" "")
     	(setq N 0)
   	(while (/= NUM N)
      		(setq EN (ssname S_TEMP N))
	  	(command "-layer" "S" "A-Wall" "")
	  	;send a wall to the buffer
  		(command "CHANGE" EN "" "P" "LA" "TEMP" "")
	  	;clear all remaining walls
		(command "-layer" "S" "A-Wall" "")
  		(command "-layer" "FREEZE" "TEMP" "FREEZE" "BORDER" "")
	  	(command "erase" "all" "")
		;setup envronment
	  	(command "-layer"  "THAW" "BORDER"  "THAW" "TEMP" "")
	  	(command "-layer" "S" "TEMP" "")
      		(handle EN robotIni)
	  	(command "OOPS")
      		(setq N (1+ N))	  
   	);while

   	;close the file
   	(setq F1 (close F1))
   	(alert "Total 6 data files have been generated!")

  	(cleanTrush)
)


;------------------------------------------------
; supporting functions
;------------------------------------------------


(defun handle (EN robotIni / N SS1 SS2 wall NUM)

	(setq SS1 (ssadd))
	(command "-boundary" robotIni "")
	(setq SS1 (ssadd (entlast) SS1))
  	;do not need the border twice
	(sendTrush SS1)
  
  	;send the wall back to its place
  	(command "-layer"  "THAW" "A-Wall" "")			
  	(command "CHANGE" EN "" "P" "LA" "A-Wall" "")	
  	(command "-layer" "FREEZE" "A-Wall" "FREEZE" "BORDER" "")
   	;get the boundary object
   	(command "select" "all" "")
   	(setq SS2 (ssget "_P") )
	(setq NUM (sslength SS2))
   	(setq N 0)
   	(while (/= NUM N)
      		(setq wall (ssname SS2 N))
      		;(setq STR "OBSTACLE")
		;(write-line STR F1)
      		(PROCESS wall)
      		(setq N (1+ N))
   	);while

  	;get rid of it
  	(sendTrush SS2)

  	;recover the old environment
  	(command "-layer"  "THAW" "BORDER" "THAW" "A-Wall" "")
  	
)

(defun cleanTrush ( )
	(command "-layer" "THAW" "TRUSH" "S" "TRUSH" "")
  	(command "-layer"  "FREEZE" "*" "")
  	(command "erase" "all" "")
  	(command "-layer" "THAW" "*" "")
  	(command "-layer" "FREEZE" "TRUSH" "FREEZE" "BORDER" "")
)

(defun sendTrush (SS1)
  	(command "-layer"  "THAW" "TRUSH" "")
  	(command "CHANGE" SS1 "" "P" "LA" "TRUSH" "")
  	(command "-layer"  "FREEZE" "TRUSH" "")
)  

(defun changeUnits ( )
 	(command "-units" "2" "1" "1" "2" "" "")
)

  
;------------------------------------------------------------------------------------			
(defun ERR (S)
   (if (= S "Function cancelled")
      (princ "\nVERTEXT - cancelled: ")
      (progn (princ "\nVERTEXT - Error: ") (princ S) (terpri)) ;_ progn
   ) ; if
   (RESETTING)
   (princ "SYSTEM VARIABLES have been reset\n")
   (princ)
) ; err
(defun SETV (SYSTVAR NEWVAL)
   (setq X (read (strcat SYSTVAR "1")))
   (set X (getvar SYSTVAR))
   (setvar SYSTVAR NEWVAL)
) ; setv 
(defun SETTING ()
   (setq OERR *ERROR*)
   (setq *ERROR* ERR)
   (SETV "CMDECHO" 0)
   (SETV "BLIPMODE" 0)
) ; end of setting 
(defun RSETV (SYSTVAR) (setq X (read (strcat SYSTVAR "1"))) (setvar SYSTVAR (eval X)))
 ; restv
(defun RESETTING () (RSETV "CMDECHO") (RSETV "BLIPMODE") (setq *ERROR* OERR))
 ; end of resetting 

(defun DXF (CODE ENAME) (cdr (assoc CODE (entget ENAME)))) ; dxf

(defun VERTEXT (EN / VLIST)
   (if (not (NULL EN))
       (progn
	   (if (= (DXF 0 EN) "LWPOLYLINE")
	      (setq VLIST (GET-LWVLIST EN))
	      (setq VLIST (GET-PLVLIST EN))
	   ) ; if
	   (WRITE-IT VLIST EN)
       )	 
   )  
  
) ;_ vertext

(defun GET-EN (/ NO-ENT EN MSG1 MSG2)
   (setq NO-ENT 1
         EN     NIL
         MSG1   "\nSelect a polyline: "
         MSG2   "\nNo polyline selected, try again."
   ) ; setq
   (while NO-ENT
      (setq EN (car (entsel MSG1)))
      (if (and EN
               (or (= (DXF 0 EN) "LWPOLYLINE") (= (DXF 0 EN) "POLYLINE")) ; or
          ) ; and
         (progn (setq NO-ENT NIL)) ; progn
         (prompt MSG2)
      ) ; if
   ) ; while
   EN
) ; get-en

(defun GET-LWVLIST (EN / ELIST NUM-VERT VLIST)
   (setq ELIST    (entget EN)
         NUM-VERT (cdr (assoc 90 ELIST))
         ELIST    (member (assoc 10 ELIST) ELIST)
         VLIST    NIL
   ) ; setq
   (repeat NUM-VERT
      (setq VLIST (append VLIST (list (cdr (assoc 10 ELIST)))) ; append
      ) ; setq
      (setq ELIST (cdr ELIST)
            ELIST (member (assoc 10 ELIST) ELIST)
      ) ; setq
   ) ; repeat
   VLIST
) ; get-lwvlist

(defun GET-PLVLIST (EN / VLIST)
   (setq VLIST NIL
         EN    (entnext EN)
   ) ; setq
   (while (/= "SEQEND" (DXF 0 EN))
      (setq VLIST (append VLIST (list (DXF 10 EN))))
      (setq EN (entnext EN))
   ) ; while
   VLIST
) ; get-plvlist

;return the last element of a list.
(defun last-elem (alist)
   (cond ((atom alist) alist)
         ((null alist) nil)
         ((null (cdr alist)) (car alist))
         (t (last-elem (cdr alist)))
   )
) 


(defun WRITE-IT (VLST EN / NEWVLIST MSG3 FNAME)
   (setq NEWVLIST (mapcar '(lambda (X) (trans X EN 0)) ;_ lambda
                          VLST
                  ) ;_ mapcar

   ) ; setq
   
   ;append all points into global variable 'visibilityPoints' 
   (setq visibilityPoints
   	(append visibilityPoints  NEWVLIST)
   )	
   ;(print visibilityPoints)
   
   ;create lines then append into global variable 'obstacleLines'

   (setq tempList (list))
   ;(makeLines NEWVLIST)	;store in tempList
   (setq obstacleLines
   	(append obstacleLines tempList)
   )	
   (setq tempList (list));clean tempList
   
   ;close the line
   (setq obstacleLines 
   	(cons (list (car NEWVLIST) (last-elem NEWVLIST)) obstacleLines)
   )
   
   ;(print obstacleLines)
   
   ;(WRITE-HEADER)
   (WRITE-VERTICES NEWVLIST)
     
   
) ;_ write-it

(defun WRITE-ROBOT-HEADER (/ STR)
   (setq STR "--ROBOT'S INITIAL AND GOAL POSITIONS--")
   (write-line STR F1)
   (setq STR (strcat "  X            " "  Y            " "  Z") ;_ strcat
   ) ;_ setq
   (write-line STR F1)
) ;_ write-header

(defun WRITE-HEADER (/ STR)
   (setq STR "--VERTEX POINTS OF AN OBSTACLE--")
   (write-line STR F1)
   (setq STR (strcat "  X            " "  Y            " "  Z") ;_ strcat
   ) ;_ setq
   (write-line STR F1)
) ;_ write-header

(defun WRITE-VERTICES (NEWVLIST / XSTR YSTR ZSTR STR)
   ;(setq STR (rtos (length NEWVLIST) 2 0))
   ;(write-line STR F1)
   (setq STR "")
   (foreach ITEM NEWVLIST
      (setq XSTR (rtos (/ (nth 0 ITEM) SCALE) 2 4)
            YSTR (rtos (/ (nth 1 ITEM) SCALE) 2 4)
            ;ZSTR (rtos (nth 2 ITEM) 2 4)
            STR  (strcat STR "(" XSTR "," YSTR ") ") ;_ strcat
      ) ; setq
      
   ) ; foreach
   (write-line STR F1)
) ; write-vertices

(defun SPACES (STR / FIELD NUM CHAR SPACE)
   (setq FIELD 15
         NUM   (- FIELD (strlen STR))
         CHAR  " "
         SPACE ""
   ) ;_ setq
   (repeat NUM (setq SPACE (strcat SPACE CHAR))) ;_ repeat
) ;_ spaces

(defun PROCESS (EN) 
	(SETTING) (VERTEXT EN) (RESETTING) (princ)
) ; PROCESS

(prompt "\Motion Planner, Xiaoshan Pan")
(prompt "\nEnter MOTIONPLAN to start")
(prompt "\nEnter SHOWPATH to display a path file")